#!/bin/bash


stack() {
    dst="${1}.png"
    shift
    A=( "$@" )
    args=( "tmp/${A[0]}.png" )
    i=1
    len="${#A[@]}"
    echo "Combine [$@] ($len) -> $dst"
    while [ $i -lt $len ]; do
        fn="tmp/${A[i]}.png"
        #args+=("$fn" -composite -transparent)
        args+=(-page +0+0 "$fn")
        let i++
    done
    #args+=("$dst")
    args+=(-compose src-over -background none -layers merge -flatten "$dst")
    #echo convert "${args[@]}"
    convert "${args[@]}"
}

mkhead() {
    prefix="$1"
    suffix="$2"
    if [ ${#suffix} -gt 0 ]; then
        suffix="-$suffix"
    fi 
    shift 2
    stack "${prefix}${suffix}" "$@"
}

allexpr() {
    prefix="$1"
    shift 1
    mkhead "$prefix" "" "jaw normal" "face mouth normal" face "eyes normal" "$@"
    mkhead "$prefix" blink "jaw normal" "face mouth normal" face "$@"
    mkhead "$prefix" happy "jaw normal" "face mouth normal" "mouth smile override" face "eyes closed smile" "$@"
    
    mkhead "$prefix" smile "jaw normal" "face mouth normal" face "mouth smile override" "eyes normal" "$@"
    mkhead "$prefix" evilsmile "jaw normal" "face mouth normal" face "mouth smile override" "eyes angry" "$@"
    mkhead "$prefix" woot "jaw normal" "face mouth normal" face "mouth smile override" "eyes shocked" "$@"
   
    mkhead "$prefix" talk "jaw open 1" "face mouth normal" face "eyes normal" "$@"
    mkhead "$prefix" shock "jaw open 1" "face mouth normal" face "eyes shocked" "$@"
    mkhead "$prefix" pain "jaw open 1" "face mouth normal" face "$@"
    
    rawr=(tongue "jaw open 2 teeth" "jaw open 2" "face angry teeth" "face mouth angry" face)
    mkhead "$prefix" angry "${rawr[@]}" "eyes angry" "$@"
    mkhead "$prefix" pain2 "${rawr[@]}" "$@"
    mkhead "$prefix" shock2 "${rawr[@]}" "eyes shocked" "$@"
    
}

allexpr head helmet
allexpr head_1 "ear" bald "ear"
allexpr head_2 "ear" "hair" 
allexpr head_3 "ear" "hair+ring" 
